<template>
  <div class="user">
    <nav
      class="breadcrumb"
      aria-label="breadcrumbs"
    />
    <div
      class="card"
    >
      <header class="card-header has-background-primary py-2">
        <p class="card-header-title is-size-3 has-text-weight-semibold has-text-white">
          POS
        </p>
        <div class="card-header-icon" />
      </header>
      <div class="card-content">
        <div class="columns">
          <div class="column is-9">
            asd
          </div>
          <div class="column is-3">
            asd
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import debounce from 'lodash/debounce';

export default {

  data () {
    return {
      users: [],
      message: 'Data is Empty!',
      search: '',
      total: 0,
      loading: false,
      sortField: 'users.id',
      sortOrder: 'asc',
      defaultSortOrder: 'asc',
      page: 1,
      perPage: 5,
      perPages: [
        { text: 'Show item 5', value: '5' },
        { text: 'Show item 10', value: '10' },
        { text: 'Show item 15', value: '15' }
      ],
      isComponentModalActive: false,
      id: null
    };
  },
  computed: {
    // mix the getters into computed with object spread operator
    rows () {
      return this.total;
    }
  },
  created () {
    this.getAllUserIndex();
  },
  methods: {
    searchUser: debounce(function () {
      this.getAllUserIndex();
    }, 500),
    getAllUserIndex: function () {
      const params = [
        `search=${this.search}`,
        `order_by=${this.sortField}`,
        `order_direction=${this.sortOrder}`,
        `page=${this.page}`,
        `per_page=${this.perPage}`,
        `status=${this.status}`
      ].join('&');
      this.loading = true;
      this.$store.dispatch('getAllUserIndex', params).then(response => {
        if (response.data != null) {
          this.users = response.data;
        } else {
          this.users = [];
          this.message = 'Data is Empty!';
        }
        this.total = response.total;
      }).catch(error => {
        this.users = [];
        this.message = error;
      }).finally(() => {
        this.loading = false;
      });
    },
    onPageChange (page) {
      this.page = page;
      this.getAllUserIndex();
    },
    onSort (field, order) {
      this.sortField = field;
      this.sortOrder = order;
      this.getAllUserIndex();
    },
    deleteUser (id) {
      this.$buefy.dialog.confirm({
        title: 'Confirmation',
        message: 'Are you sure delete this Data?',
        confirmText: 'Yes',
        cancelText: 'No',
        type: 'is-danger',
        hasIcon: true,
        onConfirm: () => {
          if (id) {
            this.$store
              .dispatch('deleteUser', id)
              .then(() => {
                this.$buefy.toast.open({
                  message: 'Success delete User',
                  type: 'is-success'
                });
                this.getAllUserIndex();
              })
              .catch(err => {
                this.$buefy.toast.open({
                  message: err,
                  type: 'is-danger'
                });
              });
          }
        }
      });
    },
    openModal: function (id) {
      this.id = id;
      this.isComponentModalActive = true;
    }
  }
};
</script>
<style scoped>
.user{
  padding: 60px;
}
</style>
